#include <linux/module.h>  
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/timer.h>
#include <linux/sysctl.h>
#include <linux/ctype.h>

static int interval = 5000;

/* two integer items (files) */
static ctl_table hello_table[] = {
        {
	 .procname="hello_interval",
         .data=&interval, 
         .maxlen=sizeof(int), 
	.mode=0644,
        .proc_handler=&proc_dointvec, 
        }, {}
};

static struct ctl_table_header *hello_table_header=NULL;

static struct timer_list tm;

static void tm_handler(unsigned long param);
static void arm_timer(void);

static void arm_timer(void)
{
  tm.expires=jiffies+(interval*HZ)/1000; 
  tm.data=0;
  tm.function = tm_handler;
  add_timer(&tm);
}

static void tm_handler(unsigned long param)
{
  printk("jiffies now %lu\n", jiffies);
  arm_timer();
}

static int __init hello_start(void)
{
  hello_table_header = register_sysctl_table(hello_table);
        if (!hello_table_header)
                return -ENOMEM;

  printk(KERN_INFO "Loading hello module...\n");
  printk(KERN_INFO "Hello world\n");

  // now start a timer
  init_timer(&tm);

  arm_timer();
  
  return 0;
}

static void __exit hello_end(void)
{
  unregister_sysctl_table(hello_table_header);
  printk(KERN_INFO "bye bye\n");
  del_timer(&tm);
}

module_init(hello_start);
module_exit(hello_end);
